// azka dev

var { default: fetch } = require("node-fetch");
// var { Api } = require("./api");

class Telegram {

    constructor(token, options = {}) {
        this.options = {
            botPath: "/bot/",
            userPath: "/user/",
            port: 8080,
            api: 'https://api.telegram.org/bot{token_bot}/{method}',
            logger: false,
            ...options,
        };
        this.token = token;
    }

    async invoke({
        method = "",
        parameters = {},
        is_form_data = false,
        tokenBot = null
    } = {
            method: "",

            parameters: {},
            is_form_data: false,
            tokenBot: null
        }) {
        parameters ??= {};


        var res = await fetch(this.options.api.replace(RegExp("{token_bot}", ""), tokenBot ?? this.token).replace(RegExp("{method}", ""), method), {
            "method": "POST",
            "headers": {
                "Content-Type": "application/json"
            },
            body: JSON.stringify(parameters)
        },);

        if (res.status == 200){
            return await res.json();
        } else {
            throw await res.json();
        }
    }

}

module.exports = {
    Telegram
};